'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _selectn = require('selectn');

var _selectn2 = _interopRequireDefault(_selectn);

var _buildQueryTree = require('./build-query-tree');

var _buildQueryTree2 = _interopRequireDefault(_buildQueryTree);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

class GraphqlQueryTree {

  constructor(info) {
    let keepRoot = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

    this._tree = (0, _buildQueryTree2.default)(info, keepRoot);
    this._parentType = (0, _buildQueryTree.getType)(info.parentType).name;
    this._returnType = (0, _buildQueryTree.getType)(info.returnType).name;
    this._parentField = info.path.key;
  }

  isSelected(path) {
    return !!this.getArguments(path);
  }

  getArguments(path) {
    const tree = path ? (0, _selectn2.default)(path, this._tree) : this._tree;
    return tree && tree['$args'] ? tree['$args'] : null;
  }

  getChildFields(path) {
    const tree = path ? (0, _selectn2.default)(path, this._tree) : this._tree;
    return tree ? Object.keys(tree).filter(key => key[0] !== '$') : null;
  }

  getType(path) {
    const tree = path ? (0, _selectn2.default)(path, this._tree) : this._tree;
    return tree && tree['$type'] ? tree['$type'] : null;
  }

  getParentType() {
    return this._parentType;
  }

  getReturnType() {
    return this._returnType;
  }

  getParentField() {
    return this._parentField;
  }

}exports.default = GraphqlQueryTree;
;